<?php

if (! defined('ABSPATH')) exit;
/**
 * @package SmsSend
 * @version 1.0.0
 */
/*
  Plugin Name: BULK SMS PLANS SMS Notifications
  Plugin URI: https://bulksmsplans.com/assets/plugin/bulksmsplans-sms-notification-v3.zip
  Description: Using this plugin you can send custom sms as well as woocommerce order place, cancel, delivery messages etc..
  Author: Bulk SMS Plans Developer Team
  Version: 1.0.0
  Author URI: https://www.bulksmsplans.com
  License: GPLv2 or later
  License URI: https://www.gnu.org/licenses/gpl-2.0.html
 */

/*
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */

// Make sure we don't expose any info if called directly



if (!function_exists('add_action')) {
    echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
    exit;
}
define('BULKSMS_SEND', '1.0.1');
define('BULKSMS_MINIMUM_WP_VERSION', '1.0');
define('BULKSMS_PLUGIN_DIR', plugin_dir_path(__FILE__));
define('BULKSMS_DELETE_LIMIT', 100000);
define('BULKSMSPLANS_SMS_SEND_VERSION', '1.0.1');

function bulksms_enqueue_assets()
{
    wp_enqueue_style('sendsms-styles', plugin_dir_url(__FILE__) . 'admin/css/sendsms-styles.css', array(), BULKSMS_SEND);
    wp_enqueue_script('sendsms-scripts', plugin_dir_url(__FILE__) . 'admin/js/sendsms-scripts.js', array(), BULKSMS_SEND, true);
}
add_action('admin_enqueue_scripts', 'bulksms_enqueue_assets');

require_once BULKSMS_PLUGIN_DIR . '/includes/wabridge.php';


register_activation_hook(__FILE__, 'BULKSMS_install');

function bulksms_install()
{
    add_option('bulksmsplans_api_key', 'xyz');
    add_option('bulksmsplans_api_token', 'xyz');
    add_option('bulksmsplans_sender', 'DEMOSM');
    add_option('bulksmsplans_msgtype', '1');
    add_option('bulksmsplans_WooCommerce', 'deactivate');
    add_option('bulksmsplans_url_key', 'IGh0dHBzOi8vd3d3LmJ1bGtzbXNwbGFucy5jb20vYXBpL3NlbmRfc21z');
    add_option('bulksmsplans_url_message_status', 'aHR0cHM6Ly93d3cuYnVsa3Ntc3BsYW5zLmNvbS9SZXN0YXBpcy9zbXNfZGVsaXZlcnlfcmVwb3J0');
    add_option('bulksmsplans_enabled_wc_checkout_form', '0');
    add_option('bulksmsplans_new_order_place', 'Order Received We have received your order id {{Order_id}} amounting to Rs.{{Order_total}}.');
    add_option('bulksmsplans_pending_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been pending.');
    add_option('bulksmsplans_processing_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been proceed.');
    add_option('bulksmsplans_on_hold_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been on-hold.');
    add_option('bulksmsplans_completed_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been completed.');
    add_option('bulksmsplans_cancelled_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been cancelled.');
    add_option('bulksmsplans_failed_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been failed.');
    add_option('bulksmsplans_new_order_place_active_deactive', '0');
    add_option('bulksmsplans_pending_order_active_deactive', '0');
    add_option('bulksmsplans_processing_order_active_deactive', '0');
    add_option('bulksmsplans_on_hold_order_active_deactive', '0');
    add_option('bulksmsplans_completed_order_active_deactive', '0');
    add_option('bulksmsplans_cancelled_order_active_deactive', '0');
    add_option('bulksmsplans_failed_order_active_deactive', '0');
    add_option('bulksmsplans_refunded_order_active_deactive', '0');
    add_option('bulksmsplans_refunded_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been refuded amount Rs.{{Order_total}}');
    add_option('bulksmsplans_checkout_otp', '{{OTP}} is your one time password to proceed on bulksmsplans. Do not share your OTP with anyone.');

    // wabridge fields
    add_option('wabridge_app_key', '');
    add_option('wabridge_auth_key', '');
    add_option('wabridge_device_id', '');
    add_option('wabridge_WooCommerce', 'deactivate');
    add_option('wabridge_url_key', 'aHR0cHM6Ly93ZWIud2FicmlkZ2UuY29tL2FwaS9jcmVhdGVtZXNzYWdl');
    add_option('wabridge_url_message_status', 'aHR0cHM6Ly93d3cuYnVsa3Ntc3BsYW5zLmNvbS9SZXN0YXBpcy9zbXNfZGVsaXZlcnlfcmVwb3J0');
    add_option('wabridge_enabled_wc_checkout_form', '0');
    add_option('wabridge_new_order_place', 'Order Received We have received your order id {{Order_id}} amounting to Rs.{{Order_total}}.');
    add_option('wabridge_pending_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been pending.');
    add_option('wabridge_processing_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been proceed.');
    add_option('wabridge_on_hold_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been on-hold.');
    add_option('wabridge_completed_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been completed.');
    add_option('wabridge_cancelled_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been cancelled.');
    add_option('wabridge_failed_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been failed.');
    add_option('wabridge_new_order_place_active_deactive', '0');
    add_option('wabridge_pending_order_active_deactive', '0');
    add_option('wabridge_processing_order_active_deactive', '0');
    add_option('wabridge_on_hold_order_active_deactive', '0');
    add_option('wabridge_completed_order_active_deactive', '0');
    add_option('wabridge_cancelled_order_active_deactive', '0');
    add_option('wabridge_failed_order_active_deactive', '0');
    add_option('wabridge_refunded_order_active_deactive', '0');
    add_option('wabridge_refunded_order', 'Hello, {{user_name}} Your Order id {{Order_id}} has been refuded amount Rs.{{Order_total}}');
    add_option('wabridge_checkout_otp', '{{OTP}} is your one time password to proceed on bulksmsplans. Do not share your OTP with anyone.');
    add_option('wabridge_failed_order_template_id', '');
    add_option('wabridge_refunded_order_template_id', '');
    add_option('wabridge_cancelled_order_template_id', '');
    add_option('wabridge_completed_order_template_id', '');
    add_option('wabridge_on_hold_order_template_id', '');
    add_option('wabridge_processing_order_template_id', '');
    add_option('wabridge_pending_order_template_id', '');
    add_option('wabridge_new_order_place_template_id', '');

    
    global $wpdb;


    $table_name = $wpdb->prefix . "blk_sms_logs";

    $charset_collate = $wpdb->get_charset_collate();

    $sql = "CREATE TABLE $table_name (
		id INT(12)  AUTO_INCREMENT PRIMARY KEY,
                request text NOT NULL,
                response text NOT NULL,
                status VARCHAR(255) NOT NULL DEFAULT 'Pending',
                api_call DATETIME NULL DEFAULT NULL
	) $charset_collate;";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);

    $table_name_2 = $wpdb->prefix . "wa_sms_logs";

    $charset_collate = $wpdb->get_charset_collate();

    $sql2 = "CREATE TABLE $table_name_2 (
		id INT(12)  AUTO_INCREMENT PRIMARY KEY,
                request text NOT NULL,
                response text NOT NULL,
                status VARCHAR(255) NOT NULL DEFAULT 'Pending',
                api_call DATETIME NULL DEFAULT NULL
	) $charset_collate;";


    dbDelta($sql2);
}

// shot code 
add_shortcode('BULKSMS_PLUGIN', 'BULKSMS_send_sms_shortcode');

function BULKSMS_send_sms_shortcode($user_data)
{
    // Define the option keys to retrieve
    $option_keys = array(
        'bulksmsplans_url_key',
        'bulksmsplans_api_key',
        'bulksmsplans_api_token',
        'bulksmsplans_sender',
        'bulksmsplans_msgtype'
    );

    // Try to get the options from cache first
    $cached_data = wp_cache_get('bulk_sms_options', 'options');

    if ($cached_data === false) {
        // If cache doesn't exist, fetch from the database using get_option()
        $cached_data = array();
        foreach ($option_keys as $key) {
            $cached_data[$key] = get_option($key);
        }

        // Cache the data for future use
        wp_cache_set('bulk_sms_options', $cached_data, 'options');
    }

    if (!empty($cached_data['bulksmsplans_url_key'])) {
        $msg_data = urlencode($user_data['msg']);
        $url_custom = "";
        $url = base64_decode($cached_data['bulksmsplans_url_key']) . "?receiver=" . $user_data['phone_number'] . "&sms=" . $msg_data;

        // Loop through the options to build the custom URL
        foreach ($cached_data as $key => $value) {
            if ($key !== 'bulksmsplans_url_key') {
                $url_custom .= "&" . trim(str_replace("bulksmsplans_", '', $key)) . "=" . $value;
            }
        }

        $full_path_url = $url . $url_custom;
        $response = wp_remote_retrieve_body(wp_remote_get($full_path_url, array('sslverify' => false, 'timeout' => 60)));

        // Insert the request and response data into the logs table
        global $wpdb;
        $table_name = $wpdb->prefix . "blk_sms_logs";
        $wpdb->insert(
            $table_name,
            array(
                'request' => wp_json_encode($user_data),
                'response' => $response,
            )
        );

        // Process the API response
        $response = json_decode($response);
        if ($response->code == 200) {
            return 1;
        } else {
            return $response->message;
        }
    } else {
        return 'SMS configuration is missing or invalid.';
    }
}

function bulksms_send($phone, $msg)
{
    $status = do_shortcode(sprintf(
        '[BULKSMS_PLUGIN phone_number="%s" msg="%s"]',
        esc_attr($phone),
        esc_attr($msg)
    ));

    return $status;
}


// check woocommerce plugin active or not
if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {

    //new order
    add_action('woocommerce_new_order', 'BULKSMS_order_place', 1, 1);

    function bulksms_order_place($order_id)
    {
        if (! $order_id) {
            return;
        }

        $order = wc_get_order($order_id);
        if (! $order) {
            return;
        }

        $phone = $order->get_billing_phone();
        $name  = $order->get_billing_first_name();
        $id    = $order->get_id();
        $total = $order->get_total();

        if (! empty($phone)) {
            $tracking_code = bulksms_shipment_tracking($order_id);
            $option_name = 'bulksmsplans_new_order_place_active_deactive';
            $data_active_deactive = get_option($option_name);


            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive->option_value == 1) {
                    

                    $option_name = 'bulksmsplans_new_order_place';

                    $data_blk_new_order_place = get_option($option_name);

                  

                    if (isset($data_blk_new_order_place) && !empty($data_blk_new_order_place)) {

                        $data_blk_new_order_place = str_replace("{{user_name}}", $name, $data_blk_new_order_place);
                        $data_blk_new_order_place = str_replace("{{tracking_code}}", $tracking_code, $data_blk_new_order_place);
                        $data_blk_new_order_place = str_replace("{{Order_id}}", $id, $data_blk_new_order_place);
                        $data_blk_new_order_place = str_replace("{{Order_total}}", $total, $data_blk_new_order_place);

                        $msg = $data_blk_new_order_place;
                    } else {
                        $msg = "Order Received We have received your order id $id amounting to Rs.$total.";
                    }

                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge

           

            $data_active_deactive = get_option('wabridge_new_order_place_active_deactive');

            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {


                    $data_wa_new_order_place = get_option('wabridge_new_order_place');

                   

                    $variable_arr = [];

                    if (isset($data_wa_new_order_place) && !empty($data_wa_new_order_place)) {

                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_new_order_place;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }


                        // $variable_arr = json_encode($variable_arr);
                    } else {
                        $message = "Order Received We have received your order id $id amounting to Rs.$total.";
                    }



                    $template_obj = get_option('wabridge_new_order_place_template_id');

                   

                    $template_id = isset($template_obj) ? $template_obj : '';


                    $variable_arr = wp_json_encode(array_values($variable_arr));

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    // order status pending

    add_action('woocommerce_order_status_pending', 'BULKSMS_mysite_pending');

    function BULKSMS_mysite_pending($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);
        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";


            $data_active_deactive = get_option('bulksmsplans_pending_order_place_active_deactive');


          
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_pending_order = get_option('bulksmsplans_pending_order');
                   

                    if (isset($data_blk_pending_order) && !empty($data_blk_pending_order)) {


                        $data_blk_pending_order = str_replace("{{user_name}}", $name, $data_blk_pending_order);
                        $data_blk_pending_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_pending_order);
                        $data_blk_pending_order = str_replace("{{Order_id}}", $id, $data_blk_pending_order);
                        $data_blk_pending_order = str_replace("{{Order_total}}", $total, $data_blk_pending_order);

                        $msg = $data_blk_pending_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been pending.";
                    }

                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge

            $data_active_deactive = get_option('wabridge_pending_order_place_active_deactive');

      
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_wa_pending_order = get_option('wabridge_pending_order');

                

                    $variable_arr = [];

                    if (isset($data_wa_pending_order) && !empty($data_wa_pending_order)) {


                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_pending_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been pending.";
                    }


                    $template_id = get_option('wabridge_pending_order_template_id');

                 

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    // order status processing
    add_action('woocommerce_order_status_processing', 'BULKSMS_mysite_processing');

    function BULKSMS_mysite_processing($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);
        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            $data_active_deactive = get_option('bulksmsplans_processing_order_active_deactive');

         
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_processing_order = get_option('bulksmsplans_processing_order');

                  
                    if (isset($data_blk_processing_order) && !empty($data_blk_processing_order)) {

                        $data_blk_processing_order = str_replace("{{user_name}}", $name, $data_blk_processing_order);
                        $data_blk_processing_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_processing_order);
                        $data_blk_processing_order = str_replace("{{Order_id}}", $id, $data_blk_processing_order);
                        $data_blk_processing_order = str_replace("{{Order_total}}", $total, $data_blk_processing_order);

                        $msg = $data_blk_processing_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been proceed.";
                    }


                    BULKSMS_send($phone, $msg);
                }
            }


            //for wabridge
            $data_active_deactive = get_option('wabridge_processing_order_active_deactive');
          
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_wa_processing_order = get_option('wabridge_processing_order');

                  
                    $variable_arr = [];
                    if (isset($data_wa_processing_order) && !empty($data_wa_processing_order)) {

                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_processing_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been proceed.";
                    }


                    $template_id = $wpdb->get_row(
                        $wpdb->prepare(
                            "SELECT * FROM {$wpdb->options} WHERE `option_name` = %s",
                            'wabridge_new_order_place_template_id'
                        )
                    );
                

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    // order status on-hold
    add_action('woocommerce_order_status_on-hold', 'BULKSMS_mysite_hold');

    function BULKSMS_mysite_hold($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);
        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            $data_active_deactive = get_option('bulksmsplans_on_hold_order_active_deactive');

            
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_on_hold_order = get_option('bulksmsplans_on_hold_order');

                   
                    if (isset($data_blk_on_hold_order) && !empty($data_blk_on_hold_order)) {

                        $data_blk_on_hold_order = str_replace("{{user_name}}", $name, $data_blk_on_hold_order);
                        $data_blk_on_hold_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_on_hold_order);
                        $data_blk_on_hold_order = str_replace("{{Order_id}}", $id, $data_blk_on_hold_order);
                        $data_blk_on_hold_order = str_replace("{{Order_total}}", $total, $data_blk_on_hold_order);

                        $msg = $data_blk_on_hold_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been on hold.";
                    }
                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge

            $data_active_deactive = get_option('wabridge_on_hold_order_active_deactive');

        
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_wa_on_hold_order = get_option('wabridge_on_hold_order');

                   
                    $variable_arr = [];
                    if (isset($data_wa_on_hold_order) && !empty($data_wa_on_hold_order)) {

                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_on_hold_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been on hold.";
                    }

                    $template_id = $wpdb->get_row(
                        $wpdb->prepare(
                            "SELECT * FROM {$wpdb->options} WHERE `option_name` = %s",
                            'wabridge_new_order_place_template_id'
                        )
                    );
                    

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    function BULKSMS_shipment_tracking($order_id)
    {

        $shipment_tracking = "";
        $order = new WC_Order($order_id);
        $order_data = $order->get_meta_data();

        if (isset($order_data) && !empty($order_data) && count($order_data)) {
            foreach ($order_data as $order_data_val) {
                if ($order_data_val->key == "_wc_shipment_tracking_items") {
                    $shipment_tracking = end($order_data_val->value)['tracking_number'];
                }
            }
        }
        return $shipment_tracking;
    }

    // order status completed
    add_action('woocommerce_order_status_completed', 'BULKSMS_mysite_completed');

    function BULKSMS_mysite_completed($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);
        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            $data_active_deactive = get_option('bulksmsplans_completed_order_active_deactive');

            
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_completed_order = get_option('bulksmsplans_completed_order');

                    
                    if (isset($data_blk_completed_order) && !empty($data_blk_completed_order)) {

                        $data_blk_completed_order = str_replace("{{user_name}}", $name, $data_blk_completed_order);
                        $data_blk_completed_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_completed_order);
                        $data_blk_completed_order = str_replace("{{Order_id}}", $id, $data_blk_completed_order);
                        $data_blk_completed_order = str_replace("{{Order_total}}", $total, $data_blk_completed_order);

                        $msg = $data_blk_completed_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been completed.";
                    }
                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge

            $data_active_deactive = get_option('wabridge_completed_order_active_deactive');

           
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_wa_completed_order = get_option('wabridge_completed_order');
                   
                    $variable_arr = [];
                    if (isset($data_wa_completed_order) && !empty($data_wa_completed_order)) {

                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_completed_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been completed.";
                    }

                    $template_id = $wpdb->get_row(
                        $wpdb->prepare(
                            "SELECT * FROM {$wpdb->options} WHERE `option_name` = %s",
                            'wabridge_new_order_place_template_id'
                        )
                    );
                

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    // order status cancelled

    add_action('woocommerce_order_status_cancelled', 'BULKSMS_mysite_cancelled');

    function BULKSMS_mysite_cancelled($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);

        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            $data_active_deactive = get_option('bulksmsplans_cancelled_order_active_deactive');

           
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_cancelled_order = get_option('bulksmsplans_cancelled_order');

                   
                    if (isset($data_blk_cancelled_order) && !empty($data_blk_cancelled_order)) {

                        $data_blk_cancelled_order = str_replace("{{user_name}}", $name, $data_blk_cancelled_order);
                        $data_blk_cancelled_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_cancelled_order);
                        $data_blk_cancelled_order = str_replace("{{Order_id}}", $id, $data_blk_cancelled_order);
                        $data_blk_cancelled_order = str_replace("{{Order_total}}", $total, $data_blk_cancelled_order);

                        $msg = $data_blk_cancelled_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been cancelled.";
                    }
                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge
            $data_active_deactive = get_option('wabridge_cancelled_order_active_deactive');
           
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_wa_cancelled_order = get_option('wabridge_cancelled_order');

                    $variable_arr = [];
                    if (isset($data_wa_cancelled_order) && !empty($data_wa_cancelled_order)) {

                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_cancelled_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been cancelled.";
                    }

                    $template_id = $wpdb->get_row(
                        $wpdb->prepare(
                            "SELECT * FROM {$wpdb->options} WHERE `option_name` = %s",
                            'wabridge_new_order_place_template_id'
                        )
                    );

                    

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    // order status failed

    add_action('woocommerce_order_status_failed', 'BULKSMS_mysite_failed');

    function BULKSMS_mysite_failed($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);
        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            $data_active_deactive = get_option('bulksmsplans_failed_order_active_deactive');


        
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_failed_order = get_option('bulksmsplans_failed_order');

                  

                    if (isset($data_blk_failed_order) && !empty($data_blk_failed_order)) {

                        $data_blk_failed_order = str_replace("{{user_name}}", $name, $data_blk_failed_order);
                        $data_blk_failed_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_failed_order);
                        $data_blk_failed_order = str_replace("{{Order_id}}", $id, $data_blk_failed_order);
                        $data_blk_failed_order = str_replace("{{Order_total}}", $total, $data_blk_failed_order);

                        $msg = $data_blk_failed_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been failed.";
                    }

                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge
            $data_active_deactive = get_option('wabridge_failed_order_active_deactive');

          
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_wa_failed_order = get_option('wabridge_failed_order');

                  

                    $variable_arr = [];

                    if (isset($data_wa_failed_order) && !empty($data_wa_failed_order)) {

                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_failed_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been failed.";
                    }

                    $template_id = $wpdb->get_row(
                        $wpdb->prepare(
                            "SELECT * FROM {$wpdb->options} WHERE `option_name` = %s",
                            'wabridge_new_order_place_template_id'
                        )
                    );
                 

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }

    // order status refunded

    add_action('woocommerce_order_status_refunded', 'BULKSMS_mysite_refunded');

    function BULKSMS_mysite_refunded($order_id)
    {
        if (!$order_id)
            return;

        $order = new WC_Order($order_id);

        $phone = $order->get_billing_phone();
        $name = $order->get_billing_first_name();
        $id = $order->get_id();
        $total = $order->get_total_refunded();

        if (isset($phone) && !empty($phone)) {
            $tracking_code = BULKSMS_shipment_tracking($order_id);
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            $data_active_deactive = get_option('bulksmsplans_refunded_order_active_deactive');

            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {

                    $data_blk_refunded_order = get_option('bulksmsplans_refunded_order');

         
                    if (isset($data_blk_refunded_order) && !empty($data_blk_refunded_order)) {

                        $data_blk_refunded_order = str_replace("{{user_name}}", $name, $data_blk_refunded_order);
                        $data_blk_refunded_order = str_replace("{{tracking_code}}", $tracking_code, $data_blk_refunded_order);
                        $data_blk_refunded_order = str_replace("{{Order_id}}", $id, $data_blk_refunded_order);
                        $data_blk_refunded_order = str_replace("{{Order_total}}", $total, $data_blk_refunded_order);

                        $msg = $data_blk_refunded_order;
                    } else {
                        $msg = "Hello, $name Your Order id $id has been refuded amount Rs.$total";
                    }
                    BULKSMS_send($phone, $msg);
                }
            }

            //for wabridge

            $data_active_deactive = get_option('wabridge_refunded_order_active_deactive');

          
            if (isset($data_active_deactive) && !empty($data_active_deactive)) {
                if ($data_active_deactive == 1) {
                   

                    $data_wa_refunded_order = get_option('wabridge_refunded_order');
                    
                    $variable_arr = [];
                    if (isset($data_wa_refunded_order) && !empty($data_wa_refunded_order)) {


                        $find_data_variable = ["{{user_name}}", "{{tracking_code}}", "{{Order_id}}", "{{Order_total}}"];

                        $replace_data_variable = [$name, $tracking_code, $id, $total];

                        $message = $data_wa_refunded_order;



                        // Replace placeholders in the message with actual values
                        foreach ($find_data_variable as $index => $variable) {
                            if (strpos($message, $variable) !== false) {
                                $message = str_replace($variable, $replace_data_variable[$index], $message);
                                $variable_arr[$variable] = $replace_data_variable[$index];
                            }
                        }

                        $variable_arr = wp_json_encode($variable_arr);
                    } else {
                        $message = "Hello, $name Your Order id $id has been refuded amount Rs.$total";
                    }

                  
                    $template_id = get_option('wabridge_new_order_place_template_id');

                   

                    WABRIDGE_send_msg($phone, $message, $template_id, $variable_arr);
                }
            }
        }
    }
}



// add menu admin site
add_action('admin_menu', 'BULKSMS_setup_menu');

function bulksms_setup_menu()
{
    add_menu_page('SMS Notifications', 'SMS Notifications', '', 'send-sms-menu');
    add_submenu_page('send-sms-menu', 'Blk Settings', 'Blk Settings', 'manage_options', 'blk-settings', 'bulksms_send_sms_from');

    $woocommerce_active = get_option('bulksmsplans_WooCommerce');

    if ('activate' === $woocommerce_active) {
        add_submenu_page('send-sms-menu', 'Custom SMS', 'Custom SMS', 'manage_options', 'custom-sms', 'bulksms_send_custom_sms');
    }

    add_submenu_page('send-sms-menu', 'History', 'History', 'manage_options', 'sms-history', 'bulksms_history_data');
    add_submenu_page('send-sms-menu', 'SMS Send', 'SMS Send', 'manage_options', 'custom-sms-send', 'bulksms_send_sms_custom');
}

function bulksms_send_custom_sms()
{

    $option_names = array(
        'bulksmsplans_enabled_wc_checkout_form',
        'bulksmsplans_new_order_place',
        'bulksmsplans_pending_order',
        'bulksmsplans_processing_order',
        'bulksmsplans_on_hold_order',
        'bulksmsplans_completed_order',
        'bulksmsplans_cancelled_order',
        'bulksmsplans_failed_order',
        'bulksmsplans_refunded_order',
        'bulksmsplans_checkout_otp'
    );

    $data = get_options(
        $option_names
    );


   

    $where2 = array('bulksmsplans_failed_order_active_deactive', 'bulksmsplans_refunded_order_active_deactive', 'bulksmsplans_cancelled_order_active_deactive', 'bulksmsplans_completed_order_active_deactive', 'bulksmsplans_on_hold_order_active_deactive', 'bulksmsplans_processing_order_active_deactive', 'bulksmsplans_pending_order_active_deactive', 'bulksmsplans_new_order_place_active_deactive');

    $data_active = get_options(
        $where2
    );

    
?>

    <div id="wpbody-content">
        <div class="wrap">
            <h1>WooCommerce Custom Messages</h1>
            <div class="head_css_blk">
                <div class="wcs-nux__notice-logo ">
                    <a href="https://www.bulksmsplans.com/">
                        <img class="" src="<?php echo esc_url(plugins_url('/admin/images/logo_light.png', __FILE__)); ?>">


                    </a>
                </div>
                <div class="head_links_blk">
                    <a href="https://www.bulksmsplans.com/" target="_blank">www.bulksmsplans.com</a>
                </div>


            </div>
            <div class="custom_msg_div">
                <h3>Note:</h3>
                <ol class="note_list">
                    <li>if you use WooCommerce plugin then below note read.</li>
                    <li>Use <b>{{user_name}}</b> if you need an user name</li>
                    <li>Use <b>{{Order_id}}</b> if you need an order id</li>
                    <li>Use <b>{{Order_total}}</b> if you need an order total</li>
                    <li>Use <b>Advanced Shipment Tracking for WooCommerce</b> plugin if you need an <b>{{tracking_code}}</b>. <a href="https://wordpress.org/plugins/woo-advanced-shipment-tracking/" target="_black">Click here </a> for download plugin.</li>
                    <li>If you use OTP value then use <b>{{OTP}}</b></li>
                </ol>
            </div>





            <form method="post" action="<?php echo esc_url(sanitize_text_field(wp_unslash(isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : ''))); ?>">



                <table class="form-table">
                    <tbody>
                        <?php
                        if (isset($data) && !empty($data)) {
                            foreach ($data as $option_name => $option_value) {
                                if ($option_name == "bulksmsplans_enabled_wc_checkout_form") {
                        ?>
                                    <tr>
                                        <th scope="row"><label><?php esc_html_e('OTP verification on checkout page', 'bulksmsplans-sms-notifications'); ?></label></th>
                                        <td>
                                            <select name="<?php echo esc_attr($option_name); ?>">
                                                <option value="0" <?php selected($option_value, 0); ?>>OFF</option>
                                                <option value="1" <?php selected($option_value, 1); ?>>ON</option>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                                } else {
                                ?>
                                    <tr>
                                        <th scope="row"><label><?php echo esc_html(ucwords(str_replace("blk", "", str_replace("_", " ", $option_name)))); ?></label></th>
                                        <td style="width: 32%">
                                            <textarea name="<?php echo esc_attr($option_name); ?>" type="text" placeholder="Enter <?php echo esc_attr(ucfirst(str_replace("_", " ", $option_name))); ?>" class="regular-text" required><?php echo esc_textarea($option_value); ?></textarea>
                                        </td>

                                        <?php
                                        if (isset($data_active) && !empty($data_active)) {
                                            foreach ($data_active as $active_option_name => $active_option_value) {
                                                if ($option_name . "_active_deactive" == $active_option_name) {
                                        ?>
                                                    <td>
                                                        <select name="<?php echo esc_attr($active_option_name); ?>">
                                                            <option value="0" <?php selected($active_option_value, 0); ?>>Deactive</option>
                                                            <option value="1" <?php selected($active_option_value, 1); ?>>Active</option>
                                                        </select>
                                                    </td>
                                        <?php
                                                }
                                            }
                                        }
                                        ?>

                                    </tr>
                        <?php
                                }
                            }
                        }
                        ?>
                    </tbody>
                </table>
                <p class="submit">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Update Changes">
                </p>
            </form>



        </div>
        <div class="clear"></div>
    </div>
<?php
}



function bulksms_history_data()
{
    global $wpdb;
    $get_table_name = $wpdb->prefix . 'blk_sms_logs';

    // Sanitize and verify nonce
    $nonce = isset($_GET['_wpnonce']) ? sanitize_key($_GET['_wpnonce']) : '';
    if (!empty($nonce) && !wp_verify_nonce($nonce, 'pagenum_nonce')) {
        die('Nonce verification failed');
    }

    $pagenum = isset($_GET['pagenum']) ? absint($_GET['pagenum']) : 1;
    $limit = 10;
    $offset = ($pagenum - 1) * $limit;

    $cache_key = 'bulksms_history_data_' . $pagenum;
    $cached_data = wp_cache_get($cache_key);

    if ($cached_data === false) {

        // $total = $wpdb->get_var("SELECT COUNT(id) FROM $get_table_name");

        $total = $wpdb->get_var(
            $wpdb->prepare("SELECT COUNT(id) FROM %s", $get_table_name)
        );

        $num_of_pages = ceil($total / $limit);

        $questionnaire_data = $wpdb->get_results(
            $wpdb->prepare(
                "SELECT * FROM $get_table_name ORDER BY id DESC LIMIT %d, %d",
                $offset,
                $limit
            ),
            OBJECT
        );

        
        $rowcount = $wpdb->num_rows;

        $cached_data = array(
            'total' => $total,
            'num_of_pages' => $num_of_pages,
            'questionnaire_data' => $questionnaire_data,
            'rowcount' => $rowcount
        );

        wp_cache_set($cache_key, $cached_data, '', 3600); // Cache for 1 hour
    } else {
        $total = $cached_data['total'];
        $num_of_pages = $cached_data['num_of_pages'];
        $questionnaire_data = $cached_data['questionnaire_data'];
        $rowcount = $cached_data['rowcount'];
    }
?>
    <div class="wrap">
        <h1><?php esc_html_e('SMS Logs List', 'bulksmsplans-sms-notifications'); ?></h1>
        <div class="head_css_blk">
            <div class="wcs-nux__notice-logo">
                <a href="https://www.bulksmsplans.com/">
                    <img src="<?php echo esc_url(plugins_url('/admin/images/logo_light.png', __FILE__)); ?>" alt="Bulk SMS Plans Logo">
                </a>
            </div>
            <div class="head_links_blk">
                <a href="https://www.bulksmsplans.com/" target="_blank">www.bulksmsplans.com</a>
            </div>
        </div>
        <br>
        <table class="wp-list-table widefat fixed striped">
            <thead>
                <tr>
                    <th scope="col" style="width: 5%;"><?php esc_html_e('S.No', 'bulksmsplans-sms-notifications'); ?></th>
                    <th scope="col"><?php esc_html_e('Request', 'bulksmsplans-sms-notifications'); ?></th>
                    <th scope="col"><?php esc_html_e('Response', 'bulksmsplans-sms-notifications'); ?></th>
                </tr>
            </thead>
            <tbody>
                <?php
                if ($rowcount) {
                    $i = 1;
                    foreach ($questionnaire_data as $singledata) {
                        $json_decode_data = json_decode($singledata->response, true);
                ?>
                        <tr>
                            <td style="text-align: center; padding: 14px;"><?php echo esc_html($i++); ?></td>
                            <td style="text-align: center; padding: 14px;"><?php echo esc_html($singledata->request); ?></td>
                            <td style="text-align: center; padding: 14px;"><?php echo esc_html($singledata->response); ?></td>
                            <td style="text-align: center; padding: 14px; display: none;">
                                <?php
                                $status = esc_html($singledata->status); // Escape the status before using it
                                if ($status == "Pending") {
                                    echo "<span class='msg_success' style='background:#F39C12'>" . esc_html($status) . "</span>";
                                } elseif ($status == "Delivered" || $status == "Accepted" || $status == "Acknowledged") {
                                    echo "<span class='msg_success'>" . esc_html($status) . "</span>";
                                } elseif ($status == "Rejected" || $status == "Failed" || $status == "Undeliverable" || $status == "Expired" || $status == "Unknown") {
                                    echo "<span class='msg_error'>" . esc_html($status) . "</span>";
                                } elseif ($status == "DND") {
                                    echo "<span class='msg_error' style='background:#3C8DBC'>" . esc_html($status) . "</span>";
                                }
                                ?>
                            </td>
                        </tr>

                <?php
                    }
                } else {
                    echo "<td colspan='3' align='center'>" . esc_html__("No details(s) found", 'bulksmsplans-sms-notifications') . "</td>";
                }
                ?>

            </tbody>
            <tfoot>

                <?php
                $page_links = paginate_links(array(
                    'base' => add_query_arg(array(
                        'pagenum' => '%#%',
                        '_wpnonce' => wp_create_nonce('pagenum_nonce') // Adding nonce
                    )),
                    'format' => '',
                    'prev_text' => __('&laquo;', 'bulksmsplans-sms-notifications'),
                    'next_text' => __('&raquo;', 'bulksmsplans-sms-notifications'),
                    'total' => $num_of_pages,
                    'current' => $pagenum
                ));
                if ($page_links) {
                ?>

                    <tr>

                        <td colspan="4">
                            <div class="tablenav tablenav-pages" style="width: 99%;">
                                <div class="tablenav-pages" style="margin: 1em 0"><?php echo wp_kses_post($page_links); ?></div>

                            </div>
                        </td>
                    </tr>
                <?php
                }
                ?>

            </tfoot>
        </table>


    </div>

    <div class="clear"></div>



<?php
}

add_action('wp_ajax_custom_action', 'BULKSMS_custom_action_callback_wp');

function BULKSMS_custom_action_callback_wp()
{
    global $wpdb;
    $table_name = $wpdb->prefix . "options";
   

    $data_blk_url_message_status = get_option('bulksmsplans_url_message_status');
    
    $get_table_name = $wpdb->prefix . "blk_sms_logs";
    $old_time = gmdate('Y-m-d H:i:s', strtotime('-5 minutes'));
    $questionnaire_data = $wpdb->get_results($wpdb->prepare("SELECT * FROM `%s` WHERE `api_call` <= %s OR `api_call` IS NULL AND `status` IN ('Pending','Accepted') ORDER BY `%s`.`id` DESC LIMIT 0, 100", $get_table_name, $old_time, $get_table_name), OBJECT);
    $get_table_name = $wpdb->prefix . "blk_sms_logs";
    $date = gmdate('Y-m-d H:i:s');
    foreach ($questionnaire_data as $questionnaire_data_val) {
        $wpdb->query($wpdb->prepare("UPDATE `%s` SET `api_call` = %s WHERE `%s`.`id` = %d", $get_table_name, $date, $get_table_name, $questionnaire_data_val->id));
        $json_decode_data = json_decode($questionnaire_data_val->response, true);
        if (is_numeric($json_decode_data['message'])) {
            $full_path_url = base64_decode($data_blk_url_message_status) . "?message_id=" . $json_decode_data['message'];
            $response = wp_remote_retrieve_body(wp_remote_get($full_path_url));
            $response_data = json_decode($response, true);
            if (isset($response_data['data']['DLRStatus']) && !empty($response_data['data']['DLRStatus'])) {
                $status = $response_data['data']['DLRStatus'];
                global $wpdb;
                $get_table_name = $wpdb->prefix . "blk_sms_logs";

                $wpdb->query(
                    $wpdb->prepare(
                        "UPDATE $get_table_name 
                        SET status = %s 
                        WHERE id = %d",
                        $status,
                        $questionnaire_data_val->id
                    )
                );
            }
        } else {

            global $wpdb;


            $wpdb->query($wpdb->prepare("UPDATE $get_table_name SET status = %s WHERE id = %d", 'Failed', $questionnaire_data_val->id));

        }
    }
    exit();
}

// send sms pages from
function BULKSMS_send_sms_from()
{
    global $wpdb;

    $table_name = $wpdb->prefix . "options";

    $where = array('bulksmsplans_api_key', 'bulksmsplans_api_token', 'bulksmsplans_sender', 'bulksmsplans_msgtype', 'bulksmsplans_WooCommerce');
    

    $data = get_options(
        $where
    );


?>

    <div id="wpbody-content">
        <div class="wrap">
            <h1>Api Settings</h1>

            <div class="head_css_blk">
                <div class="wcs-nux__notice-logo ">
                    <a href="https://www.bulksmsplans.com/">

                        <img class="" src="<?php echo esc_url(plugins_url('/admin/images/logo_light.png', __FILE__)); ?>">

                    </a>
                </div>
                <div class="head_links_blk">
                    <a href="https://www.bulksmsplans.com/" target="_blank">www.bulksmsplans.com</a>
                </div>
            </div>
            <div class="notice notice-info">
                <p><strong>Sign up <a href="https://bulksmsplans.com/v2" target="_blank">Click</a> To Get Api Credentials.</strong></p>
            </div>

            <form method="post" action="<?php echo esc_url(sanitize_text_field(wp_unslash(isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : ''))); ?>">

                <table class="form-table">
                    <tbody>
                        <?php
                        if (isset($data) && !empty($data)) {
                            foreach ($data as $option_name => $option_value) {
                                if ($option_name == "bulksmsplans_msgtype") {
                        ?>
                                    <tr>
                                        <th scope="row"><label><?php esc_html_e('Message Type', 'bulksmsplans-sms-notifications'); ?></label></th>
                                        <td>
                                            <select name="bulksmsplans_msgtype" required="">
                                                <option value=""><?php esc_html_e('Select Type', 'bulksmsplans-sms-notifications'); ?></option>
                                                <option value="1" <?php echo (isset($option_value) && !empty($option_value)) ? selected($option_value, 1, false) : ''; ?>><?php esc_html_e('Text', 'bulksmsplans-sms-notifications'); ?></option>
                                                <option value="2" <?php echo (isset($option_value) && !empty($option_value)) ? selected($option_value, 2, false) : ''; ?>><?php esc_html_e('Unicode', 'bulksmsplans-sms-notifications'); ?></option>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                                } elseif ($option_name == "bulksmsplans_WooCommerce") {
                                ?>
                                    <tr>
                                        <th scope="row"><label><?php esc_html_e('WooCommerce', 'bulksmsplans-sms-notifications'); ?></label></th>
                                        <td>
                                            <select name="bulksmsplans_WooCommerce" required>
                                                <option value="activate" <?php echo (isset($option_value) && !empty($option_value)) ? selected($option_value, 'activate', false) : ''; ?>><?php esc_html_e('Activate', 'bulksmsplans-sms-notifications'); ?></option>
                                                <option value="deactivate" <?php echo (isset($option_value) && !empty($option_value)) ? selected($option_value, 'deactivate', false) : ''; ?>><?php esc_html_e('Deactivate', 'bulksmsplans-sms-notifications'); ?></option>
                                            </select>
                                        </td>
                                    </tr>
                                <?php
                                } else {
                                ?>
                                    <tr>
                                        <th scope="row"><label><?php echo esc_html(ucwords(str_replace('bulksmsplans', '', str_replace('_', ' ', $option_name)))); ?></label></th>
                                        <td><input name="<?php echo esc_attr($option_name); ?>" type="text" placeholder="<?php echo esc_attr('Enter ' . ucfirst(str_replace('_', ' ', $option_name))); ?>" class="regular-text" required value="<?php echo esc_attr($option_value); ?>"></td>
                                    </tr>
                        <?php
                                }
                            }
                        }
                        ?>


                    </tbody>
                </table>

                <p class="submit">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Update Changes">

                </p>
            </form>
            <div style="padding: 14px;background: #fff;">
                <h3>Use this shortcode</h3>
                <b>do_shortcode("[BULKSMS_PLUGIN phone_number='1234567890' msg='Hello!']");</b>
                <p>This is a one type of sms plugin if you want send message then copy this shortcode and paste on your code and edit phone_number (Type your Number where you want to send message) and edit msg (Write down your message that you want to send a message). Message will be sent where you want to send.</p>
            </div>

        </div>
        <div class="clear"></div>


    </div>
    <?php
}

if (isset($_POST['submit']) && !empty($_POST['submit'])) {

    if (isset($_POST['send_sms_form_nonce']) && wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['send_sms_form_nonce'])), 'send_sms_form_nonce')) {
        // Nonce is not valid, exit or handle accordingly
        die('Nonce verification failed. Please try again.');
    }

    // Sanitize input fields using appropriate WordPress sanitization functions
    $saveData = [
        'number'      => isset($_POST['number']) ? sanitize_text_field(wp_unslash($_POST['number'])) : '',
        'message'     => isset($_POST['message']) ? sanitize_textarea_field(wp_unslash($_POST['message'])) : '',
        'template_id' => isset($_POST['template_id']) ? sanitize_text_field(wp_unslash($_POST['template_id'])) : '',
        'action'      => isset($_POST['action']) ? sanitize_text_field(wp_unslash($_POST['action'])) : '',
    ];



    // Check if the action is for sending an SMS
    if (!empty($saveData['action']) && $saveData['action'] == "send_sms_form") {
        $phone = $saveData['number'];
        $msg   = $saveData['message'];

        
        $send = BULKSMS_send($phone, $msg);
        if ($send == 1) {
            BULKSMS_send_custom_alert_sms('Sent SMS successfully', 1);
        } else {
            BULKSMS_send_custom_alert_sms($send, 0);
        }
        

        // Check if the action is for sending a WhatsApp message
    } elseif (!empty($saveData['action']) && $saveData['action'] == "send_wa_msg_form") {
        $phone       = $saveData['number'];
        $msg         = $saveData['message'];
        $template_id = $saveData['template_id'];

        
        $send = WABRIDGE_send_msg($phone, $msg, $template_id);
        if ($send == 1) {
            BULKSMS_send_custom_alert_sms('Message submitted successfully', 1);
        } else {
            BULKSMS_send_custom_alert_sms($send, 0);
        }
        

        // Handle any other form data updates (e.g., updating options)
    } else {

        if (!empty($_POST)) {
            global $wpdb;
            $table_name = $wpdb->prefix . "options";

            foreach ($_POST as $key => $value) {

                $sanitized_key = sanitize_key($key); // Sanitizes the key for safe storage
                $sanitized_value = sanitize_text_field(wp_unslash($value)); // Sanitizes the value

                update_option($sanitized_key, $sanitized_value);
            }
        }
    }
}



// top msg show
function BULKSMS_send_custom_alert_sms($msg, $type)
{
    if ($type) {
    ?>
        <div class="notice notice-success is-dismissible">
            <p><strong><?php echo esc_html($msg); ?></strong></p>
            <button type="button" class="notice-dismiss">
                <span class="screen-reader-text"><?php esc_html_e('Dismiss this', 'bulksmsplans-sms-notifications'); ?>.</span>
            </button>
        </div>
    <?php
    } else {
    ?>
        <div class="notice notice-error is-dismissible">
            <p><strong><?php echo esc_html($msg); ?></strong></p>
            <button type="button" class="notice-dismiss">
                <span class="screen-reader-text"><?php esc_html_e('Dismiss this', 'bulksmsplans-sms-notifications'); ?>.</span>
            </button>
        </div>
    <?php
    }
}


function BULKSMS_send_sms_custom()
{




    wp_enqueue_script('my_custom_script', plugin_dir_url(__FILE__) . '/admin/js/bulksmsplans.js', array(), '1.0', true);
    ?>

    <div id="wpbody-content">
        <div class="wrap">
            <h1>Sms Send</h1>
            <div class="head_css_blk">
                <div class="wcs-nux__notice-logo ">
                    <a href="https://www.bulksmsplans.com/">

                        <img class="" src="<?php echo esc_url(plugins_url('/admin/images/logo_light.png', __FILE__)); ?>">
                    </a>
                </div>
                <div class="head_links_blk">
                    <a href="https://www.bulksmsplans.com/" target="_blank">www.bulksmsplans.com</a>
                </div>
            </div>

            <form method="post" action="<?php echo esc_url(sanitize_text_field(wp_unslash(isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : ''))); ?>" id="send_sms_form">

                <?php wp_nonce_field('send_sms_form_nonce'); ?>
                <table class="form-table">
                    <tbody>
                        <input type="hidden" value="send_sms_form" name="action">
                        <tr>
                            <th scope="row"><label>Mobile Number </th>
                            <td><input name="number" type="text" placeholder="Enter Number" class="regular-text " id='txtPhone' required> <span id="spnPhoneStatus"></span></td>
                        </tr>
                        <tr>
                            <th scope="row"><label>Message </th>
                            <td>
                                <textarea name="message" type="text" placeholder="Enter Message" class="regular-text" id="message" required rows="5"></textarea>

                                <div>
                                    <div><span id="remaining">160</span>&nbsp;Character<span class="cplural">s</span> Remaining</div>
                                    <div>Total&nbsp;<span id="messages">1</span>&nbsp;Message<span class="mplural">s</span>&nbsp;<span id="total">0</span>&nbsp;Character<span class="tplural">s</span></div>
                                </div>
                            </td>

                        </tr>


                    </tbody>
                </table>
                <p class="submit">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Send">
                </p>
            </form>

        </div>
        <div class="clear"></div>


    </div>

    <?php
}


add_action('woocommerce_checkout_before_customer_details', 'bulksmsplans_add_custom_checkout_nonce_field');

function bulksmsplans_add_custom_checkout_nonce_field()
{
    // Add a nonce field to the checkout form
    wp_nonce_field('custom_checkout_nonce_action', 'custom_checkout_nonce');
}

add_action('init', 'BULKSMS_process_post');

function BULKSMS_process_post()
{



    global $wpdb;
    $table_name = $wpdb->prefix . "options";
    $where = "'bulksmsplans_enabled_wc_checkout_form'";


    $blk_enabled_wc_checkout_form = get_option('bulksmsplans_enabled_wc_checkout_form');


    if (($blk_enabled_wc_checkout_form == 1)) {
        add_action('woocommerce_checkout_after_terms_and_conditions', 'woocommerce_checkout_form');

        function woocommerce_checkout_form()
        {




    ?>
            <div id="blk_sms" style="display: none">
                <h3 id="blk_verifysms">SMS Verification <abbr class="required" title="required">*</abbr></h3>
                <div id="blk_sms_box" style="font-size: 15px; border: 1px solid silver; padding: 5px;">
                    <span id="blk_sms_info_display">You are required to verify your phone number using SMS verification. click on the below button to request for an OTP (One Time Password) SMS. <br><br></span>
                    <div id="msg_show" style="margin-bottom: 13px; display: none;"></div>
                    <div id="blk_sms_otp" style="margin-bottom: 10px;">
                        <input type="hidden" name="blk_phone_no" value="" id="blk_phone_no">
                        <input type="text" name="blk_sms_otp" id="blk_sms_otp_code" placeholder="Enter OTP numbers">
                        <input type="button" name="blk_submit_otp" id="blk_submit_otp" value="Submit OTP" style="margin: 7px 0px; border: 1px solid silver;  ">
                        <input type="button" name="resend_otp" id="resend_otp" value="Resend OTP" style="margin: 7px 0px; border: 1px solid silver; ">
                    </div>
                    <input type="button" name="blk_get_otp" id="blk_get_otp" value="Request OTP" style="margin: 7px 0px; border: 1px solid silver; display: none;">
                    <input type="hidden" name="blk_sms_retries" id="blk_sms_retries" value="1">
                    <input type="hidden" name="blk_check" id="blk_check" value="">
                    <input type="hidden" name="blk_sms_verified" id="blk_sms_verified" value="">
                </div>
            </div>


            <script language="Javascript">
                jQuery(document.body).on("checkout_error", function() {
                    wp_enqueue_script('jquery', '', array(), null, true);
                    var error_text = jQuery(".woocommerce-error").find("li").first().text();
                    if (error_text.includes("Please complete the SMS Verification.")) {
                        jQuery("#blk_sms").show();
                        jQuery('form[name="checkout"]').submit(function(event) {

                            var billing_phone = jQuery("#billing_phone").val();
                            var blk_phone_no = $("#blk_phone_no").val();
                            if (blk_phone_no != billing_phone) {
                                $("#blk_sms_verified").val("");
                                $("#blk_sms_otp").hide();
                                $("#blk_sms_otp_code").val("");
                                $("#blk_get_otp").show();
                                $("#msg_show").css("margin-bottom", '-22px');

                            }

                            if (jQuery.trim(jQuery("#blk_sms_verified").val()) == "") {
                                // not yet verified
                                event.preventDefault();
                                event.stopImmediatePropagation();
                                $("#msg_show").show();
                                $("#msg_show").html('<div style="background: #EBA3A3; padding: 7px 20px;"><span style="color: #761919;">Please complete the SMS Verification.</span></div><br>');
                                jQuery("#blk_sms_otp").focus();

                                document.getElementById("blk_verifysms").scrollIntoView(true);
                            }
                        });
                    }
                });
                jQuery('form[name="checkout"]').submit(function(event) {
                    if (jQuery.trim(jQuery("#blk_sms_retries").val()) == "1") {

                        var billing_phone = jQuery("#billing_phone").val();
                        $("#blk_phone_no").val(billing_phone);
                        var blk_phone_no = $("#blk_phone_no").val();
                        if (blk_phone_no == billing_phone) {
                            doOTP();
                        } else {
                            $("#blk_sms_verified").val("");
                        }


                    }
                    jQuery("#blk_sms_retries").val("0");
                });
                jQuery("#resend_otp").click(function() {
                    if (!confirm("Send OTP to " + jQuery("#blk_phone_no").val() + "?")) {
                        e.preventDefault();
                    } else {
                        doOTP();
                    }
                });

                jQuery("#blk_get_otp").click(function(e) {
                    $("#blk_phone_no").val(jQuery("#billing_phone").val());
                    var phone_num = $("#blk_phone_no").val();
                    if (phone_num == "") {
                        alert("Please enter a valid phone number.");
                        jQuery("#billing_phone").focus();
                    } else if (!confirm("Send OTP to " + phone_num + "?")) {
                        e.preventDefault();
                    } else {
                        doOTP();
                        $("#blk_sms_otp").show();
                        $("#msg_show").html('');
                        $("#msg_show").hide();
                        $("#blk_get_otp").hide();
                    }
                });

                function doOTP() {

                    var phone_num = jQuery("#blk_phone_no").val();

                    var data = {
                        "action": "blk_wc_sms_action_send",
                        "tel": phone_num
                    };
                    jQuery.ajax({
                        url: '<?php echo esc_url(admin_url('admin-ajax.php')); ?>',
                        type: 'post',
                        data: data,
                        success: function(response) {
                            if (response != 0) {
                                jQuery("#blk_check").val(response); // Changed $ to jQuery for consistency
                            }
                        }
                    });
                }


                jQuery("#blk_submit_otp").click(function(event) {

                    var otp = jQuery("#blk_sms_otp_code").val();

                    if (otp != "") {

                        var data = {
                            "action": "blk_wc_sms_action_verify",
                            "otp": otp,
                            "blk_check": jQuery("#blk_check").val()
                        };


                        jQuery.ajax({
                            type: "POST",
                            url: '<?php echo esc_url(admin_url('admin-ajax.php')); ?>',
                            data: data,
                            dataType: "text",
                            success: function(response) {
                                if (response == 0) {
                                    $("#msg_show").show();
                                    $("#msg_show").html('<div style="background: #EBA3A3; padding: 7px 20px;"><span style="color: #761919;">Please Enter Valid OPT.</span></div> <br>');
                                } else {


                                    $("#msg_show").show();
                                    $("#msg_show").html('<div style="background: #C6E1C6; padding: 7px 20px;"><span style="color: #5b841b;"> Your number has been successfully verified.</span></div> <br>');
                                    $("#blk_sms_verified").val("YES");
                                    $("#blk_sms_otp").hide();



                                }
                            }
                        });
                    } else {
                        $("#msg_show").show();
                        $("#msg_show").html('<div style="background: #EBA3A3; padding: 7px 20px;"><span style="color: #761919;">Please Enter Valid OPT.</span></div>');
                    }
                });
            </script>


<?php
        }

        add_action('woocommerce_checkout_process', 'woocommerce_checkout_process_sms');

        function woocommerce_checkout_process_sms()
        {

            // Get and sanitize the nonce field
            $nonce = isset($_POST['custom_checkout_nonce']) ? sanitize_text_field(wp_unslash($_POST['custom_checkout_nonce'])) : '';

            // Verify the nonce
            if (empty($nonce) || !wp_verify_nonce($nonce, 'custom_checkout_nonce_action')) {
                wc_add_notice(__('Nonce verification failed. Please try again.', 'bulksmsplans-sms-notifications'), 'error');
                return;
            }



            // Check if required $_POST fields are set and process them safely
            $billing_phone    = isset($_POST['billing_phone']) ? sanitize_text_field(wp_unslash($_POST['billing_phone'])) : '';
            $blk_phone_no     = isset($_POST['blk_phone_no']) ? sanitize_text_field(wp_unslash($_POST['blk_phone_no'])) : '';
            $blk_sms_verified = isset($_POST['blk_sms_verified']) ? sanitize_text_field(wp_unslash($_POST['blk_sms_verified'])) : '';

            if ($billing_phone == $blk_phone_no) {
                if ($blk_sms_verified) {
                    return;
                }
                if (empty($blk_phone_no)) {
                    wc_add_notice(esc_html__("Please enter a valid phone number. <a href='#billing_phone_field'>Click here.</a>", 'bulksmsplans-sms-notifications'), 'error');
                    return false;
                } else {
                    if (!is_numeric($blk_phone_no)) {
                        wc_add_notice(esc_html__("Please enter a valid phone number. <a href='#billing_phone_field'>Click here.</a>", 'bulksmsplans-sms-notifications'), 'error');
                        return false;
                    }
                    wc_add_notice(esc_html__("Please complete the SMS Verification. <a href='#blk_sms'>Click here for verification section.</a>", 'bulksmsplans-sms-notifications'), 'error');
                    return false;
                }
            } else {
                wc_add_notice(esc_html__("Your phone number is invalid, please enter a valid number <a href='#billing_phone_field'>Click here for verification section.</a>", 'bulksmsplans-sms-notifications'), 'error');
                return false;
            }
        }



        add_action('wp_ajax_nopriv_blk_wc_sms_action_verify', 'blksmsplans_wc_sms_action_verify_send');
        add_action('wp_ajax_blk_wc_sms_action_verify', 'blksmsplans_wc_sms_action_verify_send');

        function blksmsplans_wc_sms_action_verify_send()
        {

            /// Check if nonce is set and then unslash and sanitize it
            if (! isset($_POST['nonce']) || ! wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['nonce'])), 'ajax-nonce')) {
                die('Busted!');
            }

            // Unslash and sanitize the input
            $otp = isset($_POST['otp']) ? sanitize_text_field(wp_unslash($_POST['otp'])) : '';
            $blk_check = isset($_POST['blk_check']) ? base64_decode(sanitize_text_field(wp_unslash($_POST['blk_check']))) : '';

            if ($otp === $blk_check) {
                echo "1";
            } else {
                echo "0";
            }
            exit();
        }

        add_action('wp_ajax_nopriv_blk_wc_sms_action_send', 'blksmsplans_wc_sms_action_send_send');
        add_action('wp_ajax_blk_wc_sms_action_send', 'blksmsplans_wc_sms_action_send_send');

        function blksmsplans_wc_sms_action_send_send()
        {

            // Check if nonce is set and then unslash and sanitize it
            if (! isset($_POST['nonce']) || ! wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['nonce'])), 'ajax-nonce')) {
                die('Busted!');
            }


            if (isset($_POST['tel'])) { // Check if the 'tel' index exists
                $phone = sanitize_text_field(wp_unslash($_POST['tel'])); // Unsanitize and then sanitize
            } else {
                // Handle the case where 'tel' is not set, e.g., set $phone to null or throw an error
                $phone = null; // Or handle it as needed
            }



            // Validate that the phone number is numeric after sanitization
            if (is_numeric($phone)) {



                $six_digit_random_number = wp_rand(100000, 999999);

                global $wpdb;
                

                $blk_checkout_otp = get_option('bulksmsplans_checkout_otp');

                

                // Handle message with OTP replacement
                if (isset($blk_checkout_otp) && !empty($blk_checkout_otp)) {
                    $msg = str_replace("{{OTP}}", $six_digit_random_number, $blk_checkout_otp);
                } else {
                    $msg = "$six_digit_random_number is your one-time password to proceed on bulksmsplans. Do not share your OTP with anyone.";
                }

                // Send SMS
                BULKSMS_send($phone, $msg);

                // Return the encoded OTP
                echo esc_html(base64_encode($six_digit_random_number));
            } else {
                // Invalid phone number handling
                wc_add_notice(esc_html__("Please enter a valid phone number. <a href='#billing_phone_field'>Click here.</a>", 'bulksmsplans-sms-notifications'), 'error');
                echo 0;
            }
            exit();
        }
    }
}

//do_shortcode("[SMS_SEND_PLUGIN  phone_number='1234567890' msg='Hello!']");